Attribute VB_Name = "Publics"
Option Explicit

Public Teil(4, 2) As Integer 'Koordinatenmatrix des Steins
Public Feld(13, -2 To 19) As Integer 'Feldkoordinatenmatrix
Public linieweg(4) As Integer 'Hochkoordinate der vollstndig wegzumachenden
                              'Linien
Public VK_DOWN As Integer 'Taste fr Stein nach unten ziehen
Public VK_CYCRIGHT As Integer 'Taste fr Stein rechtsdrehen
Public VK_CYCLEFT As Integer 'Taste fr Stein linksdrehen
Public VK_LEFT As Integer 'Taste fr Stein nach links schieben
Public VK_RIGHT As Integer 'Taste fr Stein nach rechts ziehen
Public VK_SPACE As Integer 'Taste zum sofortigen droppen d. Steine

Public SOUND_FILE_SPIN As String 'Soundfile zum Drehen
Public SOUND_FILE_BRICKDOWN As String 'Soundfile zum Stein absetzen
Public SOUND_FILE_LINEFULL As String 'Soundfile fr Line lschen
Public SOUND_FILE_START As String 'Soundfile fr Startjingle
Public SOUND_FILE_ENDE As String 'Soundfile fr Ende d. Spiels
Public SOUND_FILE_WIN As String 'Spoundfile fr Ende d. Spiels gewonnen

Public status_verbindungen As Integer 'Anzahl der Verbindungen mit dem Server
Public status_server As Integer 'Status ob Server=1/Client=0 oder Offline=2
Public status_linesin As Integer 'Status wieviele Gegnerlines angekommen sind
Public status_hoehe As Integer 'Status welche Hhe die Spielsteine schon haben
Public status_gewonnen As Integer 'Gewonnen oder nicht
Public status_aktiv As Integer 'Anzahl der aktiven eingeklinkten Spieler
Public status_setup As Integer ' Gibt an welches Verzeichnis mit verzeichnis.frm
                               ' rausgesucht werden soll (Graphik oder Sound)
Public punkte As Long 'Punktestand
Public Const Spieleranzahl = 3 'Spieleranzahl (Server ist Spieler 0)
Public Clientnummer As Integer 'ID-Nummer, die man als Client vom Server bekommt
Public bildgroesse As Integer 'Hhe bzw. Breite eines Bild-Quadrates
Public linienzahl As Integer 'Anzahl der Lines, die man selber gerade eben gemacht hat
Public gestartet As Integer 'Luft Spiel gerade, oder nicht
Public Tasten As Integer 'Mit taste.frm gefangenen Taste
Public startlevel As Integer 'Ausgewhlter Startlevel
Public myname As String 'Mein Nickname
Public mycolor As Long 'Meine Chatfarbe
Public Clientport As Integer 'Port fr Client to connect to Server
Public Serverport As Integer 'Port fr Server, ber den er horcht
Public ServerIP As String 'bergebene ServerIP
Public doserver As Integer 'Soll man den Server stellen oder nicht

Public sounddir As String 'Aktives Directory der soundfiles
Public soundenabled As Integer ' 1 = Soundausgabe an, 2 = Soundausgabe aus
Public gfxdir As String 'Aktives Directory der Grafiken
Public Pfad As String ' Mit verzeichnis.frm ausgesuchter Pfad
Public shake As Integer 'Varibale zum Screenshaken

' Botvariablen
Public Botlenk As Integer ' Wenn 1, dann kann Bot den Stein lenken
Public Lage As Integer ' Drehlage der Steine
Public I As Integer ' aktueller fallender Steinbezeichnung
Public rechts As Integer ' aktueller Koordinatenrechtswert des Steins
Public Choosen As Integer ' Anzahl Aufsetzpunkte von gewhlten Botsteins
Public Choosenyxz(3) As Integer ' Gewhlt Position
Public moegaufsatz As Integer ' Anzahl mglicher Steinelemente, die aufsetzen knnen
Public Notteil(3) As Integer 'Nummer der Steinelemente, die nicht aufsetzen knnen
Public favorit(1) As Integer 'Nummer der favorisierten Lage des Steins

Public Sub select_color(ByVal Farbe As Long, ByVal nachricht As String)
 'Setzt Farbe und Nachricht richtig in Serverform-Textausgabefenster ein
 Server.txt_ausgabe.SelStart = Len(Server.txt_ausgabe.Text)
 Server.txt_ausgabe.SelLength = 0
 Server.txt_ausgabe.SelColor = Farbe
 Server.txt_ausgabe.SelText = nachricht
 Server.txt_ausgabe.SelStart = Len(Server.txt_ausgabe.Text)
End Sub

Public Function get_key_description(ByVal keycode As Integer) As String
 Select Case keycode
  Case 8
   get_key_description = "BACKSPACE"
  Case 9
   get_key_description = "TAB"
  Case 13
   get_key_description = "RETURN"
  Case 16
   get_key_description = "SHIFT"
  Case 17
   get_key_description = "CTRL"
  Case 18
   get_key_description = "ALT"
  Case 19
   get_key_description = "PAUSE"
  Case 20
   get_key_description = "CAPSLOCK"
  Case 27
   get_key_description = "ESC"
  Case 32
   get_key_description = "SPACE"
  Case 33
   get_key_description = "PGUP"
  Case 34
   get_key_description = "PGDN"
  Case 35
   get_key_description = "END"
  Case 36
   get_key_description = "HOME"
  Case 37
   get_key_description = "LEFT"
  Case 38
   get_key_description = "UP"
  Case 39
   get_key_description = "RIGHT"
  Case 40
   get_key_description = "DOWN"
  Case 45
   get_key_description = "INS"
  Case 46
   get_key_description = "DEL"
  Case 48
   get_key_description = "0"
  Case 49
   get_key_description = "1"
  Case 50
   get_key_description = "2"
  Case 51
   get_key_description = "3"
  Case 52
   get_key_description = "4"
  Case 53
   get_key_description = "5"
  Case 54
   get_key_description = "6"
  Case 55
   get_key_description = "7"
  Case 56
   get_key_description = "8"
  Case 57
   get_key_description = "9"
  Case 65
   get_key_description = "a"
  Case 66
   get_key_description = "b"
  Case 67
   get_key_description = "c"
  Case 68
   get_key_description = "d"
  Case 69
   get_key_description = "e"
  Case 70
   get_key_description = "f"
  Case 71
   get_key_description = "g"
  Case 72
   get_key_description = "h"
  Case 73
   get_key_description = "i"
  Case 74
   get_key_description = "j"
  Case 75
   get_key_description = "k"
  Case 76
   get_key_description = "l"
  Case 77
   get_key_description = "m"
  Case 78
   get_key_description = "n"
  Case 79
   get_key_description = "o"
  Case 80
   get_key_description = "p"
  Case 81
   get_key_description = "q"
  Case 82
   get_key_description = "r"
  Case 83
   get_key_description = "s"
  Case 84
   get_key_description = "t"
  Case 85
   get_key_description = "u"
  Case 86
   get_key_description = "v"
  Case 87
   get_key_description = "w"
  Case 88
   get_key_description = "x"
  Case 89
   get_key_description = "z"
  Case 90
   get_key_description = "y"
  Case 96
   get_key_description = "KP_INS"
  Case 97
   get_key_description = "KP_END"
  Case 98
   get_key_description = "KP_DOWN"
  Case 99
   get_key_description = "KP_PGDN"
  Case 100
   get_key_description = "KP_LEFT"
  Case 101
   get_key_description = "KP_5"
  Case 102
   get_key_description = "KP_RIGHT"
  Case 103
   get_key_description = "KP_HOME"
  Case 104
   get_key_description = "KP_UP"
  Case 105
   get_key_description = "KP_PGUP"
  Case 106
   get_key_description = "*"
  Case 107
   get_key_description = "KP_PLUS"
  Case 109
   get_key_description = "KP_MINUS"
  Case 110
   get_key_description = "KP_DEL"
  Case 111
    get_key_description = "-"
   'get_key_description = "KP_SLASH"
  Case 112
   get_key_description = "F1"
  Case 113
   get_key_description = "F2"
  Case 114
   get_key_description = "F3"
  Case 115
   get_key_description = "F4"
  Case 116
   get_key_description = "F5"
  Case 117
   get_key_description = "F6"
  Case 118
   get_key_description = "F7"
  Case 119
   get_key_description = "F8"
  Case 120
   get_key_description = "F9"
  Case 121
   get_key_description = "F10"
  Case 122
   get_key_description = "F11"
  Case 123
   get_key_description = "F12"
  Case 186
   get_key_description = "["
  Case 187
   get_key_description = "]"
  Case 188
   get_key_description = ","
  Case 189
   get_key_description = "/"
  Case 190
   get_key_description = "."
  Case 191
   get_key_description = "\"
  Case 192
   get_key_description = ";"
  Case 219
   get_key_description = "-"
  Case 220
   get_key_description = "`"
  Case 221
   get_key_description = "="
  Case 222
   get_key_description = "'"
  Case 226
   get_key_description = "<"
  Case Else
    MsgBox "Keycode " + CStr(keycode) + " unknown", vbOKOnly + vbExclamation, "Unknown Key"
  End Select
End Function
