Attribute VB_Name = "vertProgress"
Option Explicit

' *************** Deklarationen  fr Textdrehung Anfang

Private Declare Function CreateFont Lib "gdi32" Alias _
        "CreateFontA" (ByVal H As Long, ByVal W As Long, _
        ByVal E As Long, ByVal O As Long, ByVal W As _
        Long, ByVal I As Long, ByVal u As Long, ByVal S _
        As Long, ByVal C As Long, ByVal OP As Long, ByVal _
        CP As Long, ByVal Q As Long, ByVal PAF As Long, _
        ByVal F As String) As Long
 
Private Declare Function SelectObject Lib "gdi32" (ByVal _
        hdc As Long, ByVal hObject As Long) As Long
 
Private Declare Function DeleteObject Lib "gdi32" (ByVal _
        hObject As Long) As Long
 
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" _
        (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, _
        ByVal lpString As String, ByVal nCount As Long) As Long
        
' *************** Deklarationen  fr Textdrehung Ende


Public Function ShowProgress(PicLeiste As PictureBox, _
  ByVal Value As Long, _
  ByVal Farbe As Long, _
  Optional ByVal bShowProzent As Boolean = True)

'Nach Value rausgenommen
'ByVal Min As Long, _
'ByVal Max As Long, _
'
Dim Min As Long
Dim Max As Long
Min = 0
Max = 19 * bildgroesse

    Dim pHeight As Long
    Dim intProz As Integer
    Dim strProz As String
    
    ' Farben
    'Const progBackColor = &HC00000
    Const progForeColor = vbBlack
    Const progForeColorHighlight = vbWhite
    
    ' Plausibilittsprfungen
    If Value < Min Then Value = Min
    If Value > Max Then Value = Max
    
    ' Prozentwert ausrechnen
    If Max > 0 Then
        intProz = Int(Value / (Max - Min) * 100 + 0.5)
    Else
        intProz = 100
    End If
    
    With PicLeiste
        ' Prfen, ob AutoReadraw=True
        If .AutoRedraw = False Then .AutoRedraw = True
        
        ' Inhalt lschen
        PicLeiste.Cls
        
        If Value > 0 Then
            
            ' Balkenbreite
            pHeight = .ScaleHeight / 100 * intProz
            
            ' Balken anzeigen
            PicLeiste.Line (0, .ScaleHeight)-(.ScaleWidth, .ScaleHeight - pHeight), _
              Farbe, BF
            
            ' Prozentanzeige
            If bShowProzent Then
                strProz = CStr(intProz) & " %"
                .CurrentX = (.ScaleHeight - .TextHeight(strProz)) / 2
                .CurrentY = (.ScaleWidth - .TextWidth(strProz)) / 2
                
                ' Vordergrundfarbe
                If pHeight >= .CurrentX Then
                    .ForeColor = progForeColorHighlight
                Else
                    .ForeColor = progForeColor
                End If
                
                PicLeiste.Print strProz
            End If
        End If
    End With
End Function

Public Sub TOut(PicLeiste As PictureBox, x&, y&, Winkel&, Size%, Text$)
  Dim hFont&, FontMem&, Bold&, Result&

    If PicLeiste.FontBold Then
      Bold = 700
    Else
      Bold = 400
    End If
 
    hFont = CreateFont(-Size, 0, Winkel, 0, Bold, _
            PicLeiste.FontItalic, PicLeiste.FontUnderline, 0, 1, 4, &H10, _
            2, 4, PicLeiste.FontName)
 
    FontMem = SelectObject(PicLeiste.hdc, hFont)
    Result = TextOut(PicLeiste.hdc, x, y, Text, Len(Text))
    Result = SelectObject(PicLeiste.hdc, FontMem)
    Result = DeleteObject(hFont)
End Sub

